#!/usr/bin/env python
# -*- coding: utf-8 -*-

import threading
import re
import time
import argparse
import os
import random
import string

import setproctitle
import json

import datetime
import paho.mqtt.client as mqtt 					#import the client1

filepath="/tmp/maverickpy.log"

broker_address	="iobrokerip"
userID		="" #Benutzername
password	="" #Passwort

message 	= "starting..."
msgtext 	= ""
sensor1 	= 0
sensor2 	= 0
timestamp 	= 0
timestampLast	= 0
number		= ""
valid 		= 0 # 0 valid, 1 older than 30s, 2 older than 300s
validLast	= 0
bbq		= False
contrast	= 12
temperature	= 0
cpuTemp		= 0
cpuTempLast	= 0


def convert(message):
	if message == "True":
		return "true"
	if message == "true":
		return True
	if message == "False":
		return "false"
	if message == "false":
		return False


def on_message(client, userdata, msg):
	if msg.topic == "BBQ-Pi/message":
#		print("Message receiveid: " + msg.payload)
		global msgtext
		msgtext = msg.payload
	if msg.topic == "BBQ-Pi/brightness":
		global contrast
		if int(msg.payload) > 255:
#			device.contrast(255)
			contrast = 255
		elif int(msg.payload) < 0:
#			device.contrast(0)
			contrast = 0
		else:
#			device.contrast(int(msg.payload))
			contrast = msg.payload
	if msg.topic == "daswetter/1/NextHours/Location_1/Day_1/current/temp_value":
#		print("Temperatur: " + msg.payload)
		global temperature
		temperature = msg.payload 


def on_connect(client, userdata, flags, rc):
    #print("CONNACK received with code %d." % (rc))
    client.subscribe("mqtt/0/BBQ-Pi/#")
    client.subscribe("daswetter/1/NextHours/Location_1/Day_1/current/temp_value")


def on_disconnect(client, userdata,rc):
#    print("DisConnected result code "+str(rc))
    global msgtext
    msgtext = "connection lost..."


def get_random_filename():
    return  'test_' + ''.join(random.choice(string.ascii_uppercase + string.digits) for x in range(12))

def generateMessage():
	global msgtext
	global sensor1
	global sensor2

	if valid==0:
		tempvalid = ""
	else:
		tempvalid = "?"

	if (sensor1 > 10) and (valid != 2):	
	
		sensor1 = sensor1
		sensor2 = sensor2	
	else:
	
		sensor1 = ""
		sensor2 = ""




	set = {'time': datetime.datetime.now().strftime("%H:%M "), 'sensor1': sensor1, 'sensor2': sensor2, 'message': msgtext, 'contrast': contrast, 'temperature': temperature, 'valid': valid}

	tmp_filename = "/tmp/" + get_random_filename()
	with open(tmp_filename, 'w') as json_file:
		json_file.write(json.dumps(set))
		json_file.flush()
		os.fsync(json_file.fileno())
		json_file.close()
		os.rename(tmp_filename, "/tmp/mqtt.log")





def getTemperatures():
	jsonfile = open(filepath, "r")
	filedata = jsonfile.read()
	jsonfile.close()
	jdata = json.loads(filedata)

	f = open("/sys/class/thermal/thermal_zone0/temp", "r")
	t = f.readline ()
	f.close()


	global sensor1
	global sensor2
	global timestamp
	global timestampLast
	global cpuTemp
	global cpuTempLast

	cpuTemp = int(t)/1000

	sensor1 = jdata["temperature_1"]
	sensor2 = jdata["temperature_2"]
	timestamp = jdata["time"]

	generateMessage()



	if cpuTemp < (cpuTempLast - 3):
		client.publish("BBQ-Pi/CPU-Temp",	cpuTemp)	#publish
		cpuTempLast = cpuTemp

	if cpuTemp > (cpuTempLast + 3):
		client.publish("BBQ-Pi/CPU-Temp",	cpuTemp)	#publish
		cpuTempLast = cpuTemp


	if timestamp != timestampLast:

		client.publish("BBQ-Pi/Sensor_1",	sensor1)  	#publish
		client.publish("BBQ-Pi/Sensor_2",	sensor2)  	#publish
		client.publish("BBQ-Pi/Time",		timestamp)      #publish
		timestampLast = timestamp


def loopReadTemp():    
    # i as interval in seconds    
    threading.Timer(1,  loopReadTemp).start()    
    # put your action here
    getTemperatures()


def loopCheckValidity():
	global lastTimestamp
	global valid
	global validLast
	# i as interval in seconds    
	threading.Timer(5,  loopCheckValidity).start()    

	if (time.time() - timestamp) > 100:
		valid = 2
		if valid != validLast:
			client.publish("BBQ-Pi/status", "BBQ-Pi no reception from  ET-733 Transmitter")
			client.publish("BBQ-Pi/valid",	valid)	#publish
			validLast = valid
	elif (time.time() - timestamp) > 30:
		valid = 1
		if valid != validLast:
			client.publish("BBQ-Pi/valid",	valid)	#publish
			client.publish("BBQ-Pi/status", "BBQ-Pi no timeout from ET-733 Transmitter")
			validLast = valid
	else:
		valid = 0
		if valid != validLast:
			client.publish("BBQ-Pi/valid",	valid)	#publish
			client.publish("BBQ-Pi/status", "BBQ-Pi receiving valid data")
			validLast = valid

client = mqtt.Client("BBQ-Pi") 						#create new instance
client.username_pw_set(userID, password)				#set credentials

client.on_message = on_message
client.on_connect = on_connect
client.on_disconnect = on_disconnect

client.connect(broker_address)						#connect to broker
client.subscribe("mqtt/0/BBQ-Pi/#")


client.loop_start()

#to start 
loopCheckValidity()

loopReadTemp()

lastmessage = ""


while True:


	time.sleep(1)
